extends Node

var _connection

onready var n_Connection := get_node("Connections")

func _ready():
    _connection = n_Connection.establish_new_connection("poto.cafe", "veclavtalica", "dynamite-onlooker3-snowman")
    if _connection == null:
        push_error("Connection failed")
        return

    var service_request = load("res://scenes/PolyServiceBuilder.gd").new().request(_connection)
    if not service_request.is_done:
        yield(service_request, "done")

    if not service_request.is_ok:
        push_error("Service builder errored out: %s" % [service_request.value])
        return

    for service in service_request.value:
        if service.muc == null: continue

        var rooms_request = service.muc.request_rooms()
        if not rooms_request.is_done:
            yield(rooms_request, "done")

        if not rooms_request.is_ok:
            push_error("Room request errored out: %s" % [rooms_request.value])
            return

        for room in rooms_request.value:
            var me = service.muc.join_room(room, "tochie-facade")
